{ Algorithm: Equation: Traub's Method }

program methodOfTraub(output);
var z : real;

function solve(function f(r : real) : real; low,high : real) : real;
const minrep = 3;
var x0,x1,x2,x,y0,y1,y2,y,dx,omega,eps,delta1,delta2,s,sq : real;
	count : integer;
begin
	x0 := high;
	x1 := (low+high)/2;
	x2 := low;
	y0 := f(x0);
	y1 := f(x1);
	y2 := f(x2);
	dx := (high-low)/2;
	delta1 :=  (y0 - y1) / dx;
	
	count := 0;
	repeat
		delta2 := delta1;
		delta1 := (y0 - y1) / dx;
		eps := (delta1 - delta2) / (x0 - x2);
		omega := delta1 + (x0 - x1) * eps;
		s := omega * omega - 4 * y0 * eps;
		if 0 < s then begin
			sq := sqrt(s);
			if 0 > omega then sq := -sq;
			dx := -2 * y0 / (omega + sq);
		end else begin
			dx := -0.5 * omega / eps;
		end;
		x := x0 + dx;
		y := f(x);
		x2 := x1;
		y2 := y1;
		x1 := x0;
		y1 := y0;
		x0 := x;
		y0 := y;
		count := count + 1;
		writeLn('[', count, '] f(', x::16, ') = ', y::16);
	until (count >= minrep) and (abs(x0) >= abs(x1));
	solve := x;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.