{ Algorithm: Equation: Ostrowski's Method }

program methodOfOstrowski(output);
var z : real;

function solve(function f(r : real) : real; low,high : real) : real;
const minrep = 5;
var x0,y0,x1,y1,x2,y2,x, y,s,t,u1,u2 : real;
	count : integer;
begin
	x0 := high;
	x1 := (high+low)/2;
	x2 := low;
	y0 := f(x0);
	y1 := f(x1);
	y2 := f(x2);
	
	repeat
		u1 := y1 / y2;
		u2 := (y0 - y1) / (y0 - y2);
		s := (x0 - x1) / (x0 - x2);
		t := s * u1 / u2;
		x := (x1 - t * x2) / (1 - t);
		y := f(x);
		x2 := x1;
		y2 := y1;
		x1 := x0;
		y1 := y0;
		x0 := x;
		y0 := y;
		count := count + 1;
		writeLn('[', count, '] f(', x::16, ') = ', y::16);
	until (count >= minrep) and (abs(y0) >= abs(y1));
	solve := x;
end;

procedure print(function f(r : real) : real; x : real);
begin
	writeLn('f(',x::16, ') = ', f(x)::16);
end;

function fn(x : real) : real;
begin
	fn := cos(x) - x;
end;

{ Main }
begin
	z := solve(fn,-1.0,1.0);
	print(fn,z);
end.