{ Algorithm: Linear Equation: Complete Pivotting }

program completePivotting(output);
const n = 4;
	m = 3;
type vector = array[1..n] of real;
	matrix = array[1..n] of vector;
	vectors = array[1..m] of vector;
var aa : matrix;
	xx, bb : vectors;
	i,j,l : integer;
	
procedure swap(var x, y : real);
var temp : real;
begin
	temp := x;
	x := y;
	y := temp;
end;

procedure solve(a : matrix; var x : vectors;  b : vectors);
var i,j,k,l,iPivot,jPivot : integer;
	pivot,r,s : real;
	balancer : vector;
	order : array[1..n-1] of integer;

procedure checkPivot(x : real);
begin
	if 0.0 = x then writeLn('warning: The coefficient matrix is not full-rank.');
end;

{ solve }
begin
	{ balance the equation }
	for i := 1 to n do begin
		r := 0.0;
		for j := 1 to n do begin
			s := abs(a[i][j]);
			if r < s then r := s;
		end;
		if r = 0.0 then r := 1.0;
		for j := 1 to n do a[i][j] := a[i][j] / r;
		for l := 1 to m do b[l][i] := b[l][i] / r;
	end;
	for j := 1 to n do begin
		r := 0.0;
		for i := 1 to n do begin
			s := abs(a[i][j]);
			if r < s then r := s;
		end;
		if r = 0.0 then r := 1.0;
		for i := 1 to n do a[i][j] := a[i][j] / r;
		balancer[j] := r;
	end;
	
	for k := 1 to n-1 do begin
		{ select pivot }
		r := 0.0;
		iPivot := k;
		jPivot := k;
		for i := k to n do begin
			for j := k to n do begin
				s := abs(a[i][j]);
				if r < s then begin
					r := s;
					iPivot := i;
					jPivot := j;
				end;
			end;
		end;
		if iPivot <> k then begin
			for j := k to n do swap(a[iPivot][j], a[k][j]);
			for l := 1 to m do swap(b[l][iPivot], b[l][k]);
		end;
		if jPivot <> k then begin
			for i := 1 to n do swap(a[i][jPivot], a[i][k]);
		end;
		order[k] := jPivot;
		
		pivot := a[k][k];
		checkPivot(pivot);
		for j := k+1 to n do a[k][j] := a[k][j] / pivot;
		for l := 1 to m do b[l][k] := b[l][k] / pivot;
		for i := k+1 to n do begin
			r := a[i][k];
			for j := k+1 to n do a[i][j] := a[i][j] - a[k][j] * r;
			for l := 1 to m do b[l][i] := b[l][i] - b[l][k] * r;
		end;
	end;
	pivot := a[n][n];
	checkPivot(pivot);
	for l := 1 to m do x[l][n] := b[l][n] / pivot;
	for k := n-1 downto 1 do begin
		for l := 1 to m do begin
			r := b[l][k];
			for j := k+1 to n do r := r - a[k][j] * x[l][j];
			x[l][k] := r;
		end;
	end;
	for l := 1 to m do begin
		for k := n-1 downto 1 do swap(x[l][k], x[l][order[k]]);
		for k := 1 to n do x[l][k] := x[l][k] / balancer[k];
	end;
end;

procedure printEquation(var a : matrix; var x,b : vectors);
var i,j,l : integer;
begin
	for i := 1 to n do begin
		write('{');
		for j := 1 to n do write(a[i][j]:6:1, ' ');
		write('}{');
		for l := 1 to m do write(x[l][i]:6:1, ' ');
		if i = n div 2 then write('} = {') else write('}   {');
		for l := 1 to m do write(b[l][i]:6:1, ' ');
		writeLn('}');
	end;
end;

function getA(i,j : integer) : real;
begin
	getA := round(random * 10);
end;

function getB(l,i : integer) : real;
begin
	getB := round(random * 10);
end;

{ Main }
begin
	for i := 1 to n do for j := 1 to n do aa[i][j] := getA(i,j);
	for l := 1 to m do for i := 1 to n do bb[l][i] := getB(l,i);
	solve(aa,xx,bb);
	printEquation(aa,xx,bb);
end.