{ Algorithm: Pattern Matching: BM Matching }
program BMMatching(input,output,script);
const maxlen = 20;
	maxline = 1024;
	maxchar = 255;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	key = record
		vec : word;
		length : integer;
		skip : array[0..maxchar] of integer;
	end;
var script : text;
	w : word;
	k : key;

{ Boyer-Moore Matching Algorithm }
procedure initKey(var ky : key; var wd : word);
var i,j,len : integer;
begin
	{------- get pattern length -------}
	len := 0;
	while (maxlen > len) and (chr(0) <> wd[len]) do len := len + 1;
	ky.length := len;
	{------- set skip -------}
	for i := 0 to maxchar do ky.skip[i] := len;
	j := len - 1;
	for i := 0 to j do ky.skip[wd[i]] := j - i;
	{------- copy pattern -------}
	ky.vec := wd;
end;

function match(var ky : key; var buf : line; start : integer) : integer;
var i, j,k,n,m, len : integer;
	ch : char;
	cont : Boolean;
begin
	buf[maxline] := chr(0);
	
	j := start + ky.length - 1;
	k := -1;
	
	cont := (0 < ky.length);
	while cont and (maxline > j) do begin
		i := ky.length - 1;
		ch := buf[j];
		if chr(0) = ch then cont := false;
		while cont and (ky.vec[i] = ch) do begin
			if 0 = i then begin
				k := j;
				cont := false;
			end else begin
				i := i - 1;
				j := j - 1;
				ch := buf[j];
			end;
		end;
		if cont then begin
			n := ky.skip[ch];
			m := ky.length - i;
			if n > m then
				j := j + n
			else
				j := j + m;
		end;
	end;
	match := k;
end;

{ Read Text }
procedure matchText(var ky : key);
var buf : line;
	i,m,n,rows,count : integer;
begin
	reset(script);
	count := 0;
	rows := 0;
	while not eof(script) do begin
		readLn(script, buf);
		rows := rows + 1;
		m := 1;
		n := match(ky, buf, 0);
		if 0 <= n then begin
			writeLn('Found in line ', rows, ' (hit return to continue):');
			writeLn(buf);
			repeat
				count := count + 1;
				for i := m to n do write(' ');
				write('^');
				m := n + 2;
				n := match(ky, buf, n + 1);
			until 0 > n;
			writeLn;
			readLn;
		end;
	end;
	writeLn('Total ', count, ' times found');
end;

{ Main Routine }
begin
	write('Pattern: ');
	readLn(w);
	initKey(k, w);
	matchText(k);
end.
