{ Algorithm: Search: Binary Search }

program binarySearch(output,data);
const maxlen = 20;
	maxline = 1024;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	pcell = ^cell;
	cell = record
		left, right : pcell;
		value : word;
	end;
	
var data : text;
	header : pcell;
	w : word;
	tolower : array['A'..'Z'] of char;
	c1, c2 : char;

{ Binary Search Algorithm }
function newCell(var value : word) : pcell;
var cellNew : pcell;
begin
	new(cellNew);
	cellNew^.left := nil;
	cellNew^.right := nil;
	cellNew^.value := value;
	newCell := cellNew;
end;

function insert(list : pcell; var value : word) : pcell;
label 100;
type linkType = (linkLeft, linkRight);
var cellChild, cellParent : pcell;
	link : linkType;
begin
	cellParent := nil;
	cellChild := list;
	while nil <> cellChild do begin
		if cellChild^.value < value then begin
			cellParent := cellChild;
			link := linkRight;
			cellChild := cellChild^.right;
		end else if cellChild^.value > value then begin
			cellParent := cellChild;
			link := linkLeft;
			cellChild := cellChild^.left;
		end else
			goto 100;
	end;
100:
	if nil = cellChild then begin
		if nil = cellParent then
			list := newCell(value)
		else if linkLeft = link then
			cellParent^.left := newCell(value)
		else
			cellParent^.right := newCell(value);
	end;
	insert := list;
end;

procedure print(list : pcell);
begin
	if nil <> list then begin
		print(list^.left);
		writeLn(list^.value);
		print(list^.right);
	end;
end;

{ Text Parsing }
function parseLine(list : pcell; var buf : line) : pcell;
var i, j, k, len : integer;
	value : word;
	ch : char;
begin
	len := 0;
	for i := 0 to maxline do begin
		ch := buf[i];
		if ('A' <= ch) and ('Z' >= ch) then ch := tolower[ch];
		if ('a' <= ch) and ('z' >= ch) then begin
			if len < maxlen then begin
				value[len] := ch;
				len := len + 1;
			end;
		end else begin
			if 2 < len then begin
				for k := len to maxlen do value[k] := chr(0);
				list := insert(list, value);
			end;
			len := 0;
			if chr(0) = ch then break;
		end;
	end;
	parseLine := list;
end;

function parseText(list : pcell) : pcell;
var buf : line;
begin
	reset(data);
	while not eof(data) do begin
		readLn(data, buf);
		writeLn(buf);
		list := parseLine(list, buf);
	end;
	parseText := list;
end;

{ Main Routine }
begin
	c2 := 'a';
	for c1 := 'A' to 'Z' do begin
		tolower[c1] := c2;
		c2 := succ(c2);
	end;
	
	writeLn('Input Text:');
	header := parseText(header);

	writeLn('Contained Words:');
	print(header);
end.
