{ Algorithm: Search: Hashed Linear Search }

program hashedLinearSearch(output,data);
const maxlen = 20;
	maxline = 1024;
	hashsize = 100;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	pcell = ^cell;
	cell = record
		next : pcell;
		value : word;
	end;
	table = array[1..hashsize] of pcell;
	
var data : text;
	header : table;
	w : word;
	tolower : array['A'..'Z'] of char;
	c1, c2 : char;

{ Linear Search Algorithm }
procedure init(var tab : table);
var i : integer;
begin
	for i := 1 to hashsize do tab[i] := nil;
end;

function addHead(list : pcell; var value : word) : pcell;
var cellNew : pcell;
begin
	new(cellNew);
	cellNew^.next := list;
	cellNew^.value := value;
	addHead := cellNew;
end;

function search(list : pcell; var value : word) : Boolean;
begin
	while (nil <> list) and (list^.value <> value) do list := list^.next;
	search := (nil <> list);
end;

function hash(var value : word) : integer;
var i, key : integer;
begin
	i := 0;
	key := 0;
	while i <= maxlen do begin
		if chr(0) = value[i] then
			i := maxlen + 1
		else begin
			key := key + ord(value[i]);
			i := i + 1;
		end;
	end;
	hash := (key mod hashsize) + 1;
end;

procedure insert(var tab : table; var value : word);
var list : pcell;
	key : integer;
begin
	key := hash(value);
	list := tab[key];
	if not search(list, value) then list := addHead(list, value);
	tab[key] := list;
end;

procedure print(var tab : table);
var i : integer;
	list : pcell;
begin
	for i := 1 to hashsize do begin
		list := tab[i];
		while nil <> list do begin
			writeLn(list^.value);
			list := list^.next;
		end;
	end;
end;

{ Text Parsing }
procedure parseLine(var tab : table; var buf : line);
label 100;
var i, j, k, len : integer;
	value : word;
	ch : char;
begin
	len := 0;
	for i := 0 to maxline do begin
		ch := buf[i];
		if ('A' <= ch) and ('Z' >= ch) then ch := tolower[ch];
		if ('a' <= ch) and ('z' >= ch) then begin
			if len < maxlen then begin
				value[len] := ch;
				len := len + 1;
			end;
		end else begin
			if 2 < len then begin
				for k := len to maxlen do value[k] := chr(0);
				insert(tab, value);
			end;
			len := 0;
			if chr(0) = ch then goto 100;
		end;
	end;
100:
end;

procedure parseText(var tab : table);
var buf : line;
begin
	reset(data);
	while not eof(data) do begin
		readLn(data, buf);
		writeLn(buf);
		parseLine(tab, buf);
	end;
end;

{ Main Routine }
begin
	c2 := 'a';
	for c1 := 'A' to 'Z' do begin
		tolower[c1] := c2;
		c2 := succ(c2);
	end;
	
	init(header);
	
	writeLn('Input Text:');
	parseText(header);

	writeLn('Contained Words:');
	print(header);
end.
