{ Algorithm: Search: Modified B-Tree Search }

program modifiedBTreeSearch(input, output,data);
const maxlen = 20;
	maxline = 1024;
	maxtag = 10;
type word = packed array[0..maxlen] of char;
	line = packed array[0..maxline] of char;
	pcell = ^cell;
	nodeKind = (leaf, subtree);
	node = record
		link : pcell;
		tag : word;
	end;
	cell = record
		case phenotype : nodeKind of
			leaf : (
				value : word;
			);
			subtree : (
				max : integer;
				nodes : array[0..maxtag] of node;
			);
	end;
	
var data : text;
	header : node;
	w : word;
	tolower : array['A'..'Z'] of char;
	c1, c2 : char;

{ B*Tree Search Algorithm }
procedure init(var root : node);
var i : integer;
begin
	root.link := nil;
end;

function newLeaf(var value : word) : pcell;
var ce : pcell;
begin
	new(ce, leaf);
	ce^.phenotype := leaf;
	ce^.value := value;
	newLeaf := ce;
end;

function newTree : pcell;
var ce : pcell;
begin
	new(ce, subtree);
	ce^.phenotype := subtree;
	ce^.max := 0;
	newTree := ce;
end;

function insert_rec(var this, ins, pr, nx : node; var value : word) : pcell;
var me, parent, ret, s, d, prev, next : pcell;
	nd : node;
	n, m, count, max1, max2, pos : integer;
begin
	ins.link := nil;
	me := this.link;
	if leaf = me^.phenotype then begin
		if me^.value < value then begin
			ret := newLeaf(value);
			ins.link := ret;
			ins.tag := value;
		end else if value < me^.value then begin
			ret := newLeaf(value);
			this.link := ret;
			this.tag := value;
			ins.link := me;
			ins.tag := me^.value;
		end else begin
			ret := nil;
		end;
	end else begin	
		{-------  this is a subtree --------}
		pos := 0;
		parent := me;
		n := parent^.max;
		while 0 < n do begin
			if parent^.nodes[n].tag <= value then begin
				pos := n;
				n := 0;
			end else
				n := n - 1;
		end;
		n := pos - 1;
		m := pos + 1;
		if 0 > n then n := pos;
		if parent^.max < m then m := pos;
		me := parent^.nodes[pos].link;
		ret := insert_rec(parent^.nodes[pos], nd, 
			parent^.nodes[n], parent^.nodes[m], value);
		if 0 = pos then this.tag := parent^.nodes[0].tag;
		if nil <> nd.link then begin
			{-------  nd will be inserted after parent^.nodes[pos] --------}
			if maxtag > parent^.max then begin
				{-------  parent has some empty entry for me --------}
				pos := pos + 1;
				for n := parent^.max downto pos do begin
					parent^.nodes[n+1] := parent^.nodes[n];
				end;
				parent^.nodes[pos] := nd;
				parent^.max := parent^.max + 1;
				if 0 = pos then this.tag := nd.tag;
			end else begin
				{-------  parent has no empty entry for me --------}
				prev := pr.link;
				next := nx.link;
				if maxtag > prev^.max then begin
					{ transfer some children to the previous sibling }
					count := maxtag + prev^.max + 3;
					max1 := count div 2 - 1;
					max2 := count - max1 - 2;
					m := prev^.max + 1;
					d := prev;
					for n := 0 to maxtag do begin
						if (d = prev) and (max1 < m) then begin
							d := parent;
							m := 0;
						end;
						d^.nodes[m] := parent^.nodes[n];
						m := m + 1;
						if n = pos then begin
							if (d = prev) and (max1 < m) then begin
								d := parent;
								m := 0;
							end;
							d^.nodes[m] := nd;
							m := m + 1;
						end;
					end;
					prev^.max := max1;
					parent^.max := max2;
					this.tag := parent^.nodes[0].tag;
				end else if maxtag > next^.max then begin
					{------- transfer some children to the next sibling -------}
					count := maxtag + next^.max + 3;
					max1 := count div 2 - 1;
					max2 := count - max1 - 2;
					n := max1;
					m := next^.max;
					d := next;
					s := next;
					repeat
						if (s = parent) and (m = pos) then begin
							pos := -1;
							d^.nodes[n] := nd;
							n := n - 1;
						end else begin
							d^.nodes[n] := s^.nodes[m];
							n := n - 1;
							m := m - 1;
							if 0 > m then begin
								s := parent;
								m := maxtag;
							end;
						end;
						if 0 > n then begin
							d := parent;
							n := max2;
						end;
					until (d = parent) and (pos = -1);
					next^.max := max1;
					parent^.max := max2;
					nx.tag := next^.nodes[0].tag;
				end else if prev <> parent then begin
					{------- divide prev and parent into 3 -------}
					next := newTree;
					count := maxtag + prev^.max + 3;
					max1 := count div 3 - 1;
					max2 := count - max1 - max1 - 3;
					n := max1;
					m := maxtag;
					d := next;
					s := parent;
					repeat
						if (s = parent) and (m = pos) then begin
							pos := -1;
							d^.nodes[n] := nd;
							n := n - 1;
						end else begin
							d^.nodes[n] := s^.nodes[m];
							n := n - 1;
							m := m - 1;
							if 0 > m then begin
								s := prev;
								m := maxtag;
							end;
						end;
						if 0 > n then begin
							d := parent;
							n := max2;
						end;
					until (s = prev) and (max1 = m);
					prev^.max := max1;
					parent^.max := max2;
					next^.max := max1;
					this.tag := parent^.nodes[0].tag;
					ins.link := next;
					ins.tag := next^.nodes[0].tag;
				end else if next <> parent then begin
					{------- divide parent and next into 3 -------}
					prev := parent;
					parent := newTree;
					count := maxtag + prev^.max + 3;
					max1 := (count - 2) div 3;
					max2 := count - max1 - max1 - 3;
					if pos < max1 then begin
						m := maxtag;
						for n := maxtag - max1 downto 0 do begin
							parent^.nodes[n] := prev^.nodes[m];
							m := m - 1;
						end;
						pos := pos + 1;
						for n:= max1 downto pos+1 do begin
							prev^.nodes[n] := prev^.nodes[m];
							m := m - 1;
						end;
						prev^.nodes[pos] := nd;
					end else begin
						m := maxtag;
						for n := maxtag - max1 downto 0 do begin
							if m = pos then begin
								pos := -1;
								parent^.nodes[n] := nd;
							end else begin
								parent^.nodes[n] := prev^.nodes[m];
								m := m - 1;
							end;
						end;
					end;
					n := maxtag - max1 + 1;
					d := parent;
					for m := 0 to maxtag do begin
						d^.nodes[n] := next^.nodes[m];
						n := n + 1;
						if (d = parent) and (max2 < n) then begin
							d := next;
							n := 0;
						end;
					end;
					prev^.max := max1;
					parent^.max := max2;
					next^.max := max1;
					nx.tag := next^.nodes[0].tag;
					ins.link := parent;
					ins.tag := parent^.nodes[0].tag;
				end else begin
					{------- divide parent into 2 -------}
					next := newTree;
					max1 := maxtag div 2;
					max2 := maxtag - max1;
					n := max1;
					m := maxtag;
					d := next;
					s := parent;
					repeat
						if m = pos then begin
							pos := -1;
							d^.nodes[n] := nd;
							n := n - 1;
						end else begin
							d^.nodes[n] := s^.nodes[m];
							n := n - 1;
							m := m - 1;
						end;
						if 0 > n then begin
							d := parent;
							n := max2;
						end;
					until (d = parent) and (-1 = pos);
					parent^.max := max2;
					next^.max := max1;
					ins.link := next;
					ins.tag := next^.nodes[0].tag;
				end;
			end;
		end;
	end;
	insert_rec := ret;
end;

procedure insert(var tree : node; var value : word);
var ce : pcell;
	ins : node;
	tag : word;
begin
	if nil = tree.link then begin
		ce := newLeaf(value);
		tree.link := ce;
		tree.tag := value;
	end else begin
		ce := insert_rec(tree, ins, tree, tree, value);
		if nil <> ins.link then begin
			ce := newTree;
			ce^.max := 1;
			ce^.nodes[0].link := tree.link;
			if leaf = tree.link^.phenotype then
				ce^.nodes[0].tag := tree.link^.value
			else
				ce^.nodes[0].tag := tree.link^.nodes[0].tag;
			ce^.nodes[1] := ins;
			tree.link := ce;
		end;
	end;
end;

procedure print(tree : pcell);
var i : integer;
begin
	if nil <> tree then begin
		if leaf = tree^.phenotype then begin
			writeLn(tree^.value);
		end else begin
			for i := 0 to tree^.max do begin
				print(tree^.nodes[i].link);
			end;
		end;
	end;
end;

{ Text Parsing }
procedure parseLine(var dic : node; var buf : line);
var i, j, k, len : integer;
	value : word;
	ch : char;
begin
	len := 0;
	for i := 0 to maxline do begin
		ch := buf[i];
		if ('A' <= ch) and ('Z' >= ch) then ch := tolower[ch];
		if ('a' <= ch) and ('z' >= ch) then begin
			if len < maxlen then begin
				value[len] := ch;
				len := len + 1;
			end;
		end else begin
			if 2 < len then begin
				for k := len to maxlen do value[k] := chr(0);
				insert(dic, value);
			end;
			len := 0;
			if chr(0) = ch then break;
		end;
	end;
end;

procedure parseText(var dic : node);
var buf : line;
begin
	reset(data);
	while not eof(data) do begin
		readLn(data, buf);
		writeLn(buf);
		parseLine(dic, buf);
	end;
end;

{ Main Routine }
begin
	c2 := 'a';
	for c1 := 'A' to 'Z' do begin
		tolower[c1] := c2;
		c2 := succ(c2);
	end;
	
	writeLn('Input Text:');
	parseText(header);

	writeLn('Contained Words:');
	print(header.link);
end.
