{ Algorithm: Sort: Heap Sort }
program heapSort(output);
const n = 100;
type table = array[1..n] of integer;
var a : table;

{ Heap Sort Algorithm }
procedure validateHeap(var t : table; min, max : integer);
var i,j,w : integer;
begin
	{ note: All nodes and leaves except the top must be valid. }
	i := min;
	j := i + i;
	w := t[i];
	while j <= max do begin
		if j + 1 <= max then
			if t[j] < t[j+1] then j := j + 1;
		if w >= t[j] then begin
			j := max + 1;
		end else begin
			t[i] := t[j];
			i := j;
			j := i + i;
		end;
	end;
	t[i] := w;
end;

procedure sort(var t : table);
var i, w : integer;
begin
	{------- validate each node by bottom-up -------}
	for i := n div 2 downto 1 do validateHeap(t,i,n);
	
	{------- remove the top node repeatedly -------}
	for i := n downto 2 do begin
		w := t[1];
		t[1] := t[i];
		t[i] := w;
		validateHeap(t,1,i-1);
	end;
end;

{ Create Input Data }
procedure init(var t : table);
var i : integer;
begin
	for i := 1 to n do t[i] := trunc(random * 1000);
end;

{ Print Data }
procedure print(var t : table);
var i : integer;
begin
	for i:= 1 to n do begin
		write(t[i]:4);
		if 0 = i mod 10 then writeLn;
	end;
end;

{ Main }
begin
	init(a);
	writeLn('Input Data:');
	print(a);
	writeLn;
	sort(a);
	writeLn('Sorted Data:');
	print(a);
end.
